/*!
 * © 2021 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */

/* exported Move */
class Move {
	constructor(name,ourStatFunction,theirStatFunction) {
		this._name = name;
		this._knownMovesAndDefence = {};
		this._ourStatFunction = ourStatFunction;
		this._theirStatFunction = theirStatFunction;
	}
	addCounterMove(move,defence) {
		this._knownMovesAndDefence[move.toString()] = defence;
	}
	toString() {
		return this._name;
	}
	getOdds(theirMove,us,them) {
		const ourstat = this._ourStatFunction.call(us);
		const offense = 40;
		const theirstat = this._theirStatFunction.call(them);
		const defence = this._knownMovesAndDefence[theirMove.toString()];
		return (ourstat+offense)/(ourstat+offense+theirstat+defence)*100;
	}
}